#!/usr/bin/python
#

import sys
from sys import argv, stderr
import gth.apilib

import socket
import struct

def aal5_plain(api, ip, span, timeslots):
    command = "<new><atm_aal5_monitor vpi='0' vci='5' ip_addr='%s' ip_port='16001'>%s</atm_aal5_monitor></new>" \
        %  (ip, sources("1A", timeslots))
    api.send(command)
    api.receive_job_id()
    return

def aal5_ias(api, ip, span, timeslots, opc, dpc):
    command = "<new><atm_aal5_monitor header_type='IAS' opc='%d' dpc='%d' vpi='0' vci='5' ip_addr='%s' ip_port='2000'>%s</atm_aal5_monitor></new>" \
        %  (opc, dpc, ip, sources("1A", timeslots))
    api.send(command)
    api.receive_job_id()
    return

def sources(span, timeslots):
    "Returns a string with an XML representation of the sources"

    list = ""
    for ts in timeslots:
        list += "<pcm_source span='%s' timeslot='%d'/>" % (span, ts)

    return list

def main():
    host = "172.16.2.8"
    my_ip = "172.16.2.4"
    api = gth.apilib.API(host, 0)       # 3 = verbose debugging, 0 = debug off
    timeslots = range(1,15) + range(17,30)

    aal5_plain(api, my_ip, "1A", timeslots);
    aal5_plain(api, my_ip, "2A", timeslots);
    aal5_ias(api, my_ip, "1A", timeslots, 3, 4);
    aal5_ias(api, my_ip, "2A", timeslots, 5, 6);

    print "Job set up complete. Looping forever; ^C to abort"

    while 1:
        answer = api.next_event()
        stderr.write("G: %s\n" % answer)

    api.bye()

main()
